C************************************************************************
C************************************************************************
C******                                                          ********
C******                     Committee Model                      ********
C******           Combination of best several model              ********
C******                                                          ********
C******        H.Fujii    University of Cambridge   27/Apr/96     ********
C************************************************************************
C************************************************************************
C
C
C
C
C ***********************************************************************
C READ ME --- the procedure
C
C This program produces the energy of all data trained using all data,
C and test energy trained using half data, both for the committee model.
C
C (1)If the best number of models changes, change the nuber of the files
C     in ***'define the name of the _out files'****
C     (1-1) in go to ii (1,2,3,****************)
C     (2-2) the statement number before 'fl='**''
C     Do not exceed 99.
C (2) Compile and run.
C     The name of output is "com.dat" at the moment.
C
C ***********************************************************************
C
C
C imodel: the number of model used.
C irow:   the number of rows for the prediction.
C
C outfl:     the file name where _out files trained using all data
C            exsists.
C            exsists.
C
C For example, outfl='outfile/out10'
C              outtestfl='outtest/out10'
C
C outfile includes _out files trained using all data.
C
C _out is prediction, standard deviation, minmum and maximum.
C _ot  is target + _out
C
C
C
C************************************************************************



      implicit real*8(a-h,l-z), integer(i,j)
      
      double precision ave(10,15000),dev(10,15000),avesum(15000),
     &aveave(15000),varave(15000),avevar(15000),devcom(15000),
     &varcom(15000),
     &min(15000),max(15000),varsum(15000)
      character outfl*14, fl*3  
      


C************************************************************************      
         
       imodel=10
	open(unit=7,file='length')
       read(7,*) irow  
C ***********************************************************************


      open(3,FILE='com.dat')



C***********************************************************************
C Defining the name of _out files
C 


       do 70 ii=1,imodel
       go to (1,2,3,4,5,6,7,8,9,10,11), ii
1      fl='1'
       go to 100
2      fl='2'
       go to 100
3      fl='3'
       go to 100
4      fl='4'
       go to 100
5      fl='5'
       go to 100
6      fl='6'
       go to 100
7      fl='7'
       go to 100
8      fl='8'
       go to 100
9      fl='9'
       go to 100
10     fl='10'
       go to 100
11     fl='11'
       go to 100


      
C************************************************************************       

   
100   outfl='outprdt/out'//fl

       
      j=ii+1000

      open(j,file=outfl)


C *********************************************************************** 
C     
      imodeln=ii      
      do 30 irown=1,irow 
       read(j,*) ave(imodeln,irown), dev(imodeln,irown)

30    continue

      close(j)
      
70    continue

C ***********************************************************************
C Getting Average values of _out


         
C       write(3,110)
C       write(*,110)   

C110    format('Num of model ','All_en ','   T_en')
C110    format('Num of model ','   T_en')
           
      do 50 irown=1,irow
      
      avesum(irown)=0.0
      varsum(irown)=0.0
      aveave(irown)=0.0
      varave(irown)=0.0
      
      
        do 40 imodeln=1, imodel

            avesum(irown)=avesum(irown)+ave(imodeln,irown)
            varsum(irown)=varsum(irown)+dev(imodeln,irown)**2

40      continue

            aveave(irown)=avesum(irown)/dble(imodel)
            varave(irown)=varsum(irown)/dble(imodel)
           
50    continue

C*********************************************************************


      do 200 irown=1,irow

        avevar(irown)=0.0
        varcom(irown)=0.0
        devcom(irown)=0.0      

        do 210 imodeln=1, imodel

          avevar(irown)=avevar(irown)
     &    +(aveave(irown)-ave(imodeln,irown))**2  
            
210      continue

       varcom(irown)=varave(irown)+avevar(irown)/dble(imodel)
       devcom(irown)=sqrt(varcom(irown))
           
200    continue


C*******************************************************************


       do 300 irown=1, irow
       
       min(irown)=aveave(irown)-devcom(irown)
       max(irown)=aveave(irown)+devcom(irown)
       write(*,120) aveave(irown),devcom(irown),min(irown),max(irown)
       write(3,120) aveave(irown),devcom(irown),min(irown),max(irown)
     
300     continue


120    format(' ',F11.6,' ',F11.6,' ',F11.6,' ',F11.6)
      stop
      end
      
	
C      write(*,120) imodeln, All_en(imodeln), T_en(imodeln)
C      write(3,120) imodeln, All_en(imodeln), T_en(imodeln)   
C      write(*,120) imodeln, T_en(imodeln)
C      write(3,120) imodeln, T_en(imodeln)
